SystemOrganization addCategory: #'FLOdactic-Tests'!

TestCase subclass: #DidacticMaterialsManagerFieldsTests
	instanceVariableNames: 'material material1 material2 manager'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FLOdactic-Tests'!

!DidacticMaterialsManagerFieldsTests methodsFor: 'as yet unclassified' stamp: 'afv 5/2/2013 21:31'!
setUp
	"Variables setup for the test"
	
	material := DidacticMaterial new.
	material1 := DidacticMaterial new.
	material2 := DidacticMaterial new.
	
	manager := DidacticMaterialsManager new.! !

!DidacticMaterialsManagerFieldsTests methodsFor: 'as yet unclassified' stamp: 'afv 5/2/2013 21:35'!
testAddWithEmptyDescription
	"comment stating purpose of message"

	material uri: 'uri'; title: 'title'; type: 'type'; license: 'license'.
	
	self should: [manager add: material.] raise: Exception! !

!DidacticMaterialsManagerFieldsTests methodsFor: 'as yet unclassified' stamp: 'afv 5/2/2013 21:36'!
testAddWithEmptyLicense
	"comment stating purpose of message"

	material uri: 'uri'; title: 'title'; description: 'description'; type: 'type'.
	
	self should: [manager add: material.] raise: Exception! !

!DidacticMaterialsManagerFieldsTests methodsFor: 'as yet unclassified' stamp: 'afv 5/2/2013 21:35'!
testAddWithEmptyTitle
	"comment stating purpose of message"

	material uri: 'uri'; description: 'description'; type: 'type'; license: 'license'.
	
	self should: [manager add: material.] raise: Exception! !

!DidacticMaterialsManagerFieldsTests methodsFor: 'as yet unclassified' stamp: 'afv 5/2/2013 21:36'!
testAddWithEmptyType
	"comment stating purpose of message"

	material uri: 'uri'; title: 'title'; description: 'description'; license: 'license'.
	
	self should: [manager add: material.] raise: Exception! !

!DidacticMaterialsManagerFieldsTests methodsFor: 'as yet unclassified' stamp: 'afv 5/2/2013 21:30'!
testAddWithEmptyUri
	"comment stating purpose of message"

	material title: 'title'; description: 'description'; type: 'type'; license: 'license'.
	
	self should: [manager add: material.] raise: Exception! !

TestCase subclass: #DidacticMaterialsManagerTests
	instanceVariableNames: 'material material1 material2 manager manager1 user1 user2 testuser1 testuser2 testmaterial1 testmaterial2 testmanager1 testmaterial3 author1 author2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FLOdactic-Tests'!

!DidacticMaterialsManagerTests methodsFor: 'as yet unclassified' stamp: 'afv 5/7/2013 19:48'!
setUp
	"Variables setup for the test"
	
	author1 := Author new.
	author1 name: 'Albert De La Fuente'.
	author2 := Author new.
	author2 name: 'Igor Topcin'.
	testuser1 := User new.
	testuser1 username: 'user1'; password: 'q'; name: 'user1'; email: 'user1@flodactic.org'; role: 'user'; status: 'enabled'.
	testuser2 := User new.
	testuser2 username: 'user2'; password: 'q'; name: 'user2'; email: 'user2@flodactic.org'; role: 'user'; status: 'enabled'.

	testmaterial1 := DidacticMaterial new.
	testmaterial1 uri: 'http://www.albertdelafuente.com/doku.php/wiki/devel/python/ldap-auth';
			title: 'Python LDAP tutorial';
			description: 'A tutorial on how to use an LDAP server on Python';
			type: 'document';
			license: 'cc';
			addAuthor: author1.
			
	testmaterial2 := DidacticMaterial new.
	testmaterial2 uri: 'http://www.albertdelafuente.com/doku.php/wiki/devel/python/whatsapp-api';
			title: 'Python Whatsapp tutorial';
			description: 'A tutorial on how to use an Whatsapp API on Python';
			type: 'document';
			license: 'cc-ca';
			addAuthor: author1.
			
	testmaterial3 := DidacticMaterial new.
	testmaterial3 uri: 'https://github.com/poo2013pos/FLOdactic';
			title: 'FLOdactic: A Free Libre Open didactic management system';
			description: 'A Free Libre Open didactic management system made in Smalltalk for the 2013 OOP course at Universidade de Sao Paulo';
			type: 'Source Code';
			license: 'GPLv2';
			addAuthor: author1;
			addAuthor: author2.

	testmanager1 := DidacticMaterialsManager new.! !

!DidacticMaterialsManagerTests methodsFor: 'as yet unclassified' stamp: 'afv 5/6/2013 18:07'!
tearDown
	"Executed after the tests"
	
	testmanager1 remove: 'http://www.albertdelafuente.com/doku.php/wiki/devel/python/ldap-auth'.
	testmanager1 remove: 'http://www.albertdelafuente.com/doku.php/wiki/devel/python/whatsapp-api'.
	testmanager1 remove: 'https://github.com/poo2013pos/FLOdactic'.! !

!DidacticMaterialsManagerTests methodsFor: 'as yet unclassified' stamp: 'afv 5/4/2013 12:31'!
testAddAuthorsAgretation
	"Verifies if the created, modified and status attributes are filled automatically by the Manager"

"	testmaterial1 uri: 'uri'; title: 'title'; description: 'description'; type: 'type'; license: 'license'."
	
"	self should: [manager add: material.] raise: Exception"! !

!DidacticMaterialsManagerTests methodsFor: 'as yet unclassified' stamp: 'afv 5/4/2013 12:23'!
testAddTagsAgretation
	"Verifies if the created, modified and status attributes are filled automatically by the Manager"

	testmaterial1 uri: 'uri'; title: 'title'; description: 'description'; type: 'type'; license: 'license'.
	
"	self should: [manager add: material.] raise: Exception"! !

!DidacticMaterialsManagerTests methodsFor: 'as yet unclassified' stamp: 'afv 5/4/2013 12:23'!
testAddWithAutomaticAttributes
	"Verifies if the created, modified and status attributes are filled automatically by the Manager"

	testmaterial1 uri: 'uri'; title: 'title'; description: 'description'; type: 'type'; license: 'license'.
	
"	self should: [manager add: material.] raise: Exception"! !

!DidacticMaterialsManagerTests methodsFor: 'as yet unclassified' stamp: 'afv 5/4/2013 12:25'!
testDidacticMaterialManagerCounterIncrementsAfterAddingADidacticMaterial
	"Verifies that after adding a material the number of materials gets incremented. It might be silly since the Dictionary class should be already tested by its developers"

	| count |
"	user := User new.
	user username: 'testowner'; email: 'testuser@flodactic.org'.
	material uri: 'uri'; title: 'title'; description: 'description'; type: 'type'; license: 'license'."

	count  := testmanager1 size.
	testmanager1 owner: testuser1 add: testmaterial1.
"	testmanager1 owner: testuser1 add: testmaterial2."
	self assert: ((testmanager1 size) = (count + 1)).! !

!DidacticMaterialsManagerTests methodsFor: 'as yet unclassified' stamp: 'afv 5/6/2013 17:51'!
testNestedSelectByTitleContains
	""

	| select1 select2 |
	self tearDown.
	self setUp.
	testmanager1 owner: testuser1 add: testmaterial1.
	testmanager1 owner: testuser1 add: testmaterial2.
	select1 := testmanager1 select: [:doc | (doc title findString: 'Python') > 0].
	self assert: ((select1 size) = 2).
	
	select2 := select1 select: [:doc | (doc title findString: 'Whatsapp') > 0].
	self assert: ((select2 size) = 1).
	
! !

!DidacticMaterialsManagerTests methodsFor: 'as yet unclassified' stamp: 'afv 5/7/2013 19:54'!
testSelectAuthorsByName
	"Albert is author of 3 materials and Igor is author of 1"

	| result |
	self tearDown.
	self setUp.
	testmanager1 owner: testuser1 add: testmaterial1.
	testmanager1 owner: testuser1 add: testmaterial2.
	testmanager1 owner: testuser1 add: testmaterial3.
	
	result := testmaterial1 selectAuthorsByName: 'Albert De La Fuente'.
	self assert: ((result size) = 1).
	result := testmaterial3 selectAuthorsByName: 'Igor Topcin'.
	self assert: ((result size) = 1).! !

!DidacticMaterialsManagerTests methodsFor: 'as yet unclassified' stamp: 'afv 5/6/2013 18:14'!
testSimpleSelectByLicense
	""

	| result |
	self tearDown.
	self setUp.
	testmanager1 owner: testuser1 add: testmaterial1.
	testmanager1 owner: testuser1 add: testmaterial2.
	testmanager1 owner: testuser1 add: testmaterial3.
	result := testmanager1 select: [:doc | doc license = 'GPLv2'].
	
	self assert: ((result size) = 1).
	
! !

!DidacticMaterialsManagerTests methodsFor: 'as yet unclassified' stamp: 'afv 5/6/2013 17:58'!
testSimpleSelectByUri
	""

	| result |
	self tearDown.
	self setUp.
	testmanager1 owner: testuser1 add: testmaterial1.
	testmanager1 owner: testuser1 add: testmaterial2.
	result := testmanager1 select: [:doc | doc uri = 'http://www.albertdelafuente.com/doku.php/wiki/devel/python/ldap-auth'].
	
	self assert: ((result size) = 1).
	
! !

TestCase subclass: #FLOdacticFacadeTests
	instanceVariableNames: 'testui user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FLOdactic-Tests'!

FLOdacticFacadeTests class
	instanceVariableNames: 'testui user login'!

FLOdacticFacadeTests class
	instanceVariableNames: 'testui user login'!

!FLOdacticFacadeTests methodsFor: 'as yet unclassified' stamp: 'afv 5/10/2013 11:08'!
setUp
	"Variables setup for the test"
	
	testui := FLOdacticFacade new.
	user := User new.
	user username: 'albert'; password: 'pass'; name: 'Albert'; email: 'vonpupp@gmail.com'; role: 'user'; status: 'enabled'.
	testui addUser: user.! !

!FLOdacticFacadeTests methodsFor: 'as yet unclassified' stamp: 'afv 5/10/2013 14:11'!
tearDown
	"Executed after the test"

	testui removeUser: 'albert'.
	testui removeAll.
	testui release.
! !

!FLOdacticFacadeTests methodsFor: 'as yet unclassified' stamp: 'afv 5/4/2013 11:02'!
testFailedLoginUsernamePassword
	"comment stating purpose of message"

	self should: [testui doLogin: 'albert' password: 'wrong'..] raise: Exception.
! !

!FLOdacticFacadeTests methodsFor: 'as yet unclassified' stamp: 'afv 5/10/2013 11:00'!
testSuccessfulLoginUsernamePassword
	"comment stating purpose of message"

	| login |

	self tearDown.
	self setUp.
	testui loggedUser ifNotNil: [
		testui doLogout.
	].
	login := testui doLogin: 'albert' password: 'pass'.
	self assert: (login = true).! !

TestCase subclass: #UsersManagerFieldsTests
	instanceVariableNames: 'admin admin1 admin2 full usersManager'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FLOdactic-Tests'!

!UsersManagerFieldsTests methodsFor: 'as yet unclassified' stamp: 'afv 5/2/2013 19:38'!
setUp
	"Variables setup for the test"
	
	admin := User new.
	admin1 := User new.
	admin2 := User new.! !

!UsersManagerFieldsTests methodsFor: 'as yet unclassified' stamp: 'afv 4/30/2013 21:57'!
tearDown
	"Executed after the test"! !

!UsersManagerFieldsTests methodsFor: 'as yet unclassified' stamp: 'afv 5/1/2013 20:10'!
testAddWithEmptyEmail
	"comment stating purpose of message"

	admin username: 'admin'; password: 'q'; name: 'Leonardo Santos'; role: 'administrator'; status: 'enabled'.
	
	self should: [usersManager add: admin.] raise: Exception! !

!UsersManagerFieldsTests methodsFor: 'as yet unclassified' stamp: 'afv 5/1/2013 20:11'!
testAddWithEmptyName
	"comment stating purpose of message"

	admin username: 'admin'; password: 'q'; email: 'leo@flodactic.org'; role: 'administrator'; status: 'enabled'.
	
	self should: [usersManager add: admin.] raise: Exception! !

!UsersManagerFieldsTests methodsFor: 'as yet unclassified' stamp: 'afv 5/1/2013 20:11'!
testAddWithEmptyPassword
	"comment stating purpose of message"

	admin username: 'admin'; name: 'Leonardo Santos'; email: 'leo@flodactic.org'; role: 'administrator'; status: 'enabled'.
	
	self should: [usersManager add: admin.] raise: Exception! !

!UsersManagerFieldsTests methodsFor: 'as yet unclassified' stamp: 'afv 5/1/2013 20:11'!
testAddWithEmptyRole
	"comment stating purpose of message"

	admin username: 'admin'; password: 'q'; name: 'Leonardo Santos'; email: 'leo@flodactic.org'; status: 'enabled'.
	
	self should: [usersManager add: admin.] raise: Exception! !

!UsersManagerFieldsTests methodsFor: 'as yet unclassified' stamp: 'afv 5/1/2013 20:11'!
testAddWithEmptyStatus
	"comment stating purpose of message"

	admin username: 'admin'; password: 'q'; name: 'Leonardo Santos'; email: 'leo@flodactic.org'; role: 'administrator'.
	
	self should: [usersManager add: admin.] raise: Exception! !

!UsersManagerFieldsTests methodsFor: 'as yet unclassified' stamp: 'afv 5/1/2013 20:11'!
testAddWithEmptyUsername
	"comment stating purpose of message"

	admin password: 'q'; name: 'Leonardo Santos'; email: 'leo@flodactic.org'; role: 'administrator'; status: 'enabled'.
	
	self should: [usersManager add: admin.] raise: Exception! !

!UsersManagerFieldsTests methodsFor: 'as yet unclassified' stamp: 'afv 5/4/2013 09:50'!
testMatchUsernameMatchPassword
	"comment stating purpose of message"

	admin username: 'leo'; password: 'q'; name: 'Leonardo Santos'; email: 'leo@flodactic.org'; role: 'administrator'; status: 'enabled'.
	
	self assert: ((admin matchUsername: 'leo' matchPassword: 'q') = true).! !

!UsersManagerFieldsTests methodsFor: 'as yet unclassified' stamp: 'afv 5/4/2013 09:47'!
testUserIsEnabled
	"comment stating purpose of message"

	admin password: 'q'; name: 'Leonardo Santos'; email: 'leo@flodactic.org'; role: 'administrator'; status: 'enabled'.
	
	self assert: (admin isEnabled = true).! !

TestCase subclass: #UsersManagerTests
	instanceVariableNames: 'usersManager user user1 user2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FLOdactic-Tests'!

!UsersManagerTests methodsFor: 'as yet unclassified' stamp: 'afv 5/2/2013 19:45'!
setUp
	"Variables setup for the test"
	
	user := User new.
	user username: 'user'; password: 'q'; name: 'Leonardo Santos'; email: 'admin@flodactic.org'; role: 'administrator'; status: 'enabled'.
	
	user1 := User new.
	user2 := User new.
	usersManager := UsersManager new.! !

!UsersManagerTests methodsFor: 'as yet unclassified' stamp: 'afv 5/10/2013 14:22'!
tearDown
	"Variables setup for the test"
	
	user release.
	user1 release.
	user2 release.
	usersManager removeAll.! !

!UsersManagerTests methodsFor: 'as yet unclassified' stamp: 'afv 5/10/2013 14:20'!
testAddWithDuplicatedEmails
	"Test for duplicated emails"

	user1 username: 'admin1'; password: 'q'; name: 'Leonardo Santos'; email: 'admin@flodactic.org'; role: 'administrator'; status: 'enabled'.
	user2 username: 'admin1'; password: 'q'; name: 'Rodrigo Barbosa'; email: 'admin@flodactic.org'; role: 'administrator'; status: 'enabled'.
	usersManager add: user1.
	
	self should: [usersManager add: user2.] raise: Exception! !

!UsersManagerTests methodsFor: 'as yet unclassified' stamp: 'afv 5/9/2013 21:42'!
testAddWithDuplicatedUsername
	"Test for duplicated usernames"

	self tearDown.
	self setUp.
	user1 username: 'admin'; password: 'q'; name: 'Leonardo Santos'; email: 'leo@flodactic.org'; role: 'administrator'; status: 'enabled'.
	user2 username: 'admin'; password: 'q'; name: 'Rodrigo Barbosa'; email: 'rodrigo@flodactic.org'; role: 'administrator'; status: 'enabled'.
	usersManager add: user1.
	
	self should: [usersManager add: user2.] raise: Exception! !

!UsersManagerTests methodsFor: 'as yet unclassified' stamp: 'afv 5/2/2013 19:54'!
testDoLoginWithDisabledUser
	"comment stating purpose of message"

	user username: 'user'; password: 'q'; name: 'Leonardo Santos'; email: 'admin@flodactic.org'; role: 'administrator'; status: 'disabled'.
	
	self should: [usersManager doLogin: 'user' password: 'q'.] raise: Exception! !

!UsersManagerTests methodsFor: 'as yet unclassified' stamp: 'afv 5/2/2013 19:52'!
testDoLoginWithNonExistingUsername
	"comment stating purpose of message"

	user username: 'user'; password: 'q'; name: 'Leonardo Santos'; email: 'admin@flodactic.org'; role: 'administrator'; status: 'enabled'.
	
	self should: [usersManager doLogin: 'u' password: 'q'.] raise: Exception! !

!UsersManagerTests methodsFor: 'as yet unclassified' stamp: 'afv 5/2/2013 19:53'!
testDoLoginWithWrongPassword
	"comment stating purpose of message"

	user username: 'user'; password: 'q'; name: 'Leonardo Santos'; email: 'admin@flodactic.org'; role: 'administrator'; status: 'enabled'.
	
	self should: [usersManager doLogin: 'user' password: 'wrong'.] raise: Exception! !

!UsersManagerTests methodsFor: 'as yet unclassified' stamp: 'afv 5/2/2013 19:40'!
testRemoveWithNonExistingUsername
	"comment stating purpose of message"

	user password: 'q'; name: 'Leonardo Santos'; email: 'leo@flodactic.org'; role: 'administrator'; status: 'enabled'.
	
	self should: [usersManager remove: 'aasdasda'.] raise: Exception! !

TestCase subclass: #WorkspaceTestExample
	instanceVariableNames: 'ui01 ui02 admin01 moderator01 moderator02 albertAuthor material01 material02 floogle albertUser igorUser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FLOdactic-Tests'!

WorkspaceTestExample class
	instanceVariableNames: 'ui01 ui02 admin01 moderator01 moderator02 albertAuthor material01 material02 floogle albertUser igorUser'!

WorkspaceTestExample class
	instanceVariableNames: 'ui01 ui02 admin01 moderator01 moderator02 albertAuthor material01 material02 floogle albertUser igorUser'!

!WorkspaceTestExample methodsFor: 'as yet unclassified' stamp: 'afv 5/9/2013 21:19'!
setUp
	"Create the user's interface"
	ui01 := FLOdacticFacade new.
	ui02 := FLOdacticFacade new.
	
	"Create special users objects"
	admin01 := User new.
	moderator01 := User new.
	moderator02 := User new.
	
	admin01 username: 'admin01'; password: 'q'; name: 'Leonardo Santos'; email: 'admintest@flodactic.org'; role: 'administrator'; status: 'enabled'.
	moderator01 username: 'mod01'; password: 'q'; name: 'Rodolpho Bustamante'; email: 'mod01test@flodactic.org'; role: 'moderator'; status: 'enabled'.
	moderator02 username: 'mod02'; password: 'q'; name: 'Samuel Rodrigues'; email: 'mod02test@flodactic.org'; role: 'moderator'; status: 'enabled'.
	
	"Authors objects"
	albertAuthor := Author new.
	
	"didacticMaterialManager := DidacticMaterialsManager singleton."
	material01 := DidacticMaterial new.
	material02 := DidacticMaterial new.
	
	material01 uri: 'http://www.albertdelafuente.com/doku.php/wiki/devel/python/ldap-auth';
		title: 'Python LDAP tutorial';
		description: 'A tutorial on how to use an LDAP server on Python';
		type: 'document';
		license: 'cc';
		addAuthor: albertAuthor.

	material02 uri: 'http://www.albertdelafuente.com/doku.php/wiki/devel/python/whatsapp-api';
		title: 'Python Whatsapp tutorial';
		description: 'A tutorial on how to use an Whatsapp API on Python';
		type: 'document';
		license: 'cc'.
	
	"Create a SearchEngine"
	floogle := SearchEngine new.
	
	"r1 := dm select: [:doc | ('*' match: doc title)].
	r2 := dm select: [:doc | ('*' match: doc title)]."

	"Create regular users objects"
	albertUser := User new.
	albertUser username: 'albert'; password: 'q'; name: 'Albert De La Fuente'; email: 'albert@ime.usp.br'; role: 'user'; status: 'enabled'.
	igorUser := User new.
	igorUser username: 'igor'; password: 'q'; name: 'Igor Topcin'; email: 'igor@ime.usp.br'; role: 'user'; status: 'enabled'.
! !

!WorkspaceTestExample methodsFor: 'as yet unclassified' stamp: 'afv 5/10/2013 15:53'!
tearDown
	"User's interface"
	ui01 removeAll.
	ui02 removeAll.
	ui01 release.
	ui02 release.
	
	"Special users objects"
	admin01 release.
	moderator01 release.
	moderator02 release.
	
	"Authors objects"
	"albertAuthor release."
	
	"didacticMaterialManager := DidacticMaterialsManager singleton."
	material01 release.
	material02 release.
	
	"SearchEngine"
	floogle release.
	
	"r1 := dm select: [:doc | ('*' match: doc title)].
	r2 := dm select: [:doc | ('*' match: doc title)]."

	"Create regular users objects"
	albertUser release.
	igorUser release.
! !

!WorkspaceTestExample methodsFor: 'as yet unclassified' stamp: 'afv 5/10/2013 14:58'!
testWorkspace
	"This is an example of a possible use flow of FLOdactic."
	
	
	"First clean all and recreate the objects, so it passes future tests (avoid persistance)"
	| byAuthor results1 results2 |
	self tearDown.
	self setUp.

	"Add special users to the session"
	ui01 addUser: admin01.
	ui01 addUser: moderator01.
	ui01 addUser: moderator02.

	ui01 doLogin: 'admin01' password: 'q'.
	ui01 loggedUser.

	ui01 addMaterial: material01.
	ui01 addMaterial: material02.

	floogle := SearchEngine new.
	results1 := floogle searchDidacticMaterials: 'Python'.
	byAuthor := floogle filterByAuthor: 'Albert De La Fuente'.
	results2 := floogle addFilter: byAuthor.
	
	"r1 := dm select: [:doc | ('*' match: doc title)].
	r2 := dm select: [:doc | ('*' match: doc title)]."

	"Create regular users objects"
	albertUser := User new.
	albertUser username: 'alberttest'; password: 'q'; name: 'Albert De La Fuente'; email: 'alberttest@ime.usp.br'; role: 'user'; status: 'enabled'.
	igorUser := User new.
	igorUser username: 'topcintest'; password: 'q'; name: 'Igor Topcin'; email: 'topcintest@ime.usp.br'; role: 'user'; status: 'enabled'.

	"Add them to the FLOdactic User's Interface"
	ui01 addUser: albertUser.
	ui01 addUser: igorUser.
	
"	ui01 doLogin: 'albert' password: 'q'."! !

!WorkspaceTestExample methodsFor: 'as yet unclassified' stamp: 'afv 4/30/2013 21:24'!
testWorkspaceCommented
	"This is not really a test, is a 'persistent workspace' in order to be able to use it over git"
"
admin := User new.
admin username: 'admin'; password: 'q'; name: 'Leonardo Santos'; email: 'admin@flodactic.org'; role: 'administrator'; status: 'enabled'.
mod01 := User new.
mod01 username: 'mod01'; password: 'q'; name: 'Rodolpho Bustamante'; email: 'mod01@flodactic.org'; role: 'moderator'; status: 'enabled'.
mod02 := User new.
mod02 username: 'mod02'; password: 'q'; name: 'Rodolpho Bustamante'; email: 'mod02@flodactic.org'; role: 'moderator'; status: 'enabled'.

albert := User new.
albert username: 'vonpupp'; password: 'q'; name: 'Albert De La Fuente'; email: 'albert@ime.usp.br'; role: 'user'; status: 'enabled'.

igor := User new.
igor username: 'topcin'; password: 'q'; name: 'Igor Topcin'; email: 'topcin@ime.usp.br'; role: 'user'; status: 'enabled'.

usersManager := UserManager new.
usersManager add: admin.
usersManager add: mod01.
usersManager add: mod02.
usersManager add: albert.
usersManager add: igor.

* Create a tag (which way?)
pythonTag := Tag new: 'python'.
ldapTag := Tag new: 'LDAP'.
programmingTag := Tag new: 'programming'.
tagsManager := TagsManager new.

* Create a material
didacticMaterial := DidacticMaterial new.
didacticMaterial uri: 'http://www.albertdelafuente.com/doku.php/wiki/devel/python/ldap-auth';
				 owner: albert;
				 title: 'Python LDAP authentication';
				 tags: tags.


* Brainstorm inicial (Albert)
documento := Material new.
documento url: 'http://www.ex.com/doc.pdf' titulo: 'tutorial de Smalltalk'...
tags := ListaTags new.
tags adicionar: 'squeak' adicionar: 'desenvolvimento' adicionar: 'programacao orientada a objetos'
ca := ControleAcesso new.
ca usuario: albert material: documento permissao: modificacao receptor: albert

tags := ListaTags new.
tags adicionar: 'squeak'
busca := Buscar new.
busca usuario: albert chave: 'manual de smalltalk' tags: tags

igor := Usuario new.
igor email: 'igortopcin@gmail.com' nome: 'Igor' sobrenome: 'Topcin' senha: '1234'
usuarios := ListaUsuarios new. (herda de Collection ou List por exemplo)
usuarios adicionar: igor

sessao...

ca usuario: albert material: documento permissao: modificacao receptor: igor
documento titulo: 'tutorial de Squeak'
log acao: modificao material: documento campo: titulo por: igor no: dia

"! !
